package com.ptplib.usbcamera.test;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.strickling.usbcamera.R;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

public class MyTestAdapter extends BaseAdapter {

    private ArrayList<String> infoList;
    private Context context;
    private LayoutInflater inflater;
    private SimpleDateFormat formatter = new SimpleDateFormat("HH:mm:ss\t");

    public MyTestAdapter(Context context) {
        this.context = context;
        infoList = new ArrayList<>();
        inflater = LayoutInflater.from(context);
    }

    @Override
    public int getCount() {
        return infoList.size();
    }

    @Override
    public Object getItem(int position) {
        return infoList.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    public void addInfo(String info){
        infoList.add(formatter.format(new Date())+info);
        notifyDataSetChanged();
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        if (convertView == null) {
            convertView = inflater.inflate(R.layout.item_test_info, null);
            holder = new ViewHolder();
            holder.info = (TextView) convertView.findViewById(R.id.tv_info);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        holder.info.setText(infoList.get(position));
        return convertView;
    }

    final class ViewHolder {
        public TextView info;
    }
}
